# frozen_string_literal: true

module Hermes
  class HousingRequestShareSerializer < Hermes::ApplicationSerializer
    cache key: proc { "#{object.cache_key}" }, expires_in: 1.day
    attributes %i[
      housing_request_id
      lessor_id
      code
      expire_at
      public_url
    ]

    type 'housing_request_shares'

    def lessor_id
      object.lessor_id&.to_s
    end

    def housing_request_id
      object.housing_request_id&.to_s
    end
    
    def main_applicant_id
      object.housing_request&.main_applicant_id&.to_s
    end

    def main_applicant
      return nil unless object.housing_request&.main_applicant

      Hermes::ApplicantSerializer.new(
        object.housing_request.main_applicant,
        #scope: scope,
        root: false
      )
    end

    def entity_id
      object.housing_request&.entity_id&.to_s
    end

    def coapplicant_ids
      object.housing_request&.applicant_ids&.map(&:to_s)
    end

    def coapplicants
      object.housing_request&.coapplicants
    end
  end
end
